Adler32 (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.util.zip, class: Adler32
Keywords: java.util.zip.Adler32 class

# Class Adler32

java.lang.Object
java.util.zip.Adler32

All Implemented Interfaces:
  `Checksum`

public class Adler32 extends Object implements Checksum
A class that can be used to compute the Adler-32 checksum of a data stream. An Adler-32 checksum is almost as reliable as a CRC-32 but can be computed much faster.

Passing a `null` argument to a method in this class will cause a `NullPointerException` to be thrown.

Since:
  1.1

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Adler32()`
  Creates a new Adler32 object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `long`
  `getValue()`
  Returns the checksum value.
  `void`
  `reset()`
  Resets the checksum to initial value.
  `void`
  `update(byte[] b, int off, int len)`
  Updates the checksum with the specified array of bytes.
  `void`
  `update(int b)`
  Updates the checksum with the specified byte (the low eight bits of the argument b).
  `void`
  `update(ByteBuffer buffer)`
  Updates the checksum with the bytes from the specified buffer.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

  ### Methods declared in interface Checksum

  `update`
  Modifier and Type
  Method
  Description
  `default void`
  `update(byte[] b)`
  Updates the current checksum with the specified array of bytes.

- ## Constructor Details

  - ### Adler32

    public Adler32()
    Creates a new Adler32 object.

- ## Method Details

  - ### update

    public void update(int b)
    Updates the checksum with the specified byte (the low eight bits of the argument b).
    Specified by:
      `update` in interface `Checksum`
    Parameters:
      `b` - the byte to update the checksum with

  - ### update

    public void update(byte[] b, int off, int len)
    Updates the checksum with the specified array of bytes.
    Specified by:
      `update` in interface `Checksum`
    Parameters:
      `b` - the byte array to update the checksum with
      `off` - the start offset of the data
      `len` - the number of bytes to use for the update
    Throws:
      `ArrayIndexOutOfBoundsException` - if `off` is negative, or `len` is negative, or `off+len` is negative or greater than the length of the array `b`.

  - ### update

    public void update(ByteBuffer buffer)
    Updates the checksum with the bytes from the specified buffer. The checksum is updated with the remaining bytes in the buffer, starting at the buffer's position. Upon return, the buffer's position will be updated to its limit; its limit will not have been changed.
    Specified by:
      `update` in interface `Checksum`
    Parameters:
      `buffer` - the ByteBuffer to update the checksum with
    Since:
      1.8

  - ### reset

    public void reset()
    Resets the checksum to initial value.
    Specified by:
      `reset` in interface `Checksum`

  - ### getValue

    public long getValue()
    Returns the checksum value.
    Specified by:
      `getValue` in interface `Checksum`
    Returns:
      the current checksum value